/**
 * Program: LocalTree.java
 * Comments: Creates a tree from the local file system.
 */

import javax.swing.tree.*;
import java.io.*;
import java.lang.System;

public class LocalTree extends TreeFactory {

    static File[] files;

    public LocalTree() {;}

    //This overrides the abstract method of the parent.
    public String[] returnFiles(String dirName) {
	String[] fileList=null;
	try{
	    /* This is supported by JDK 1.2 
	    files = File.listRoots();
	    for(int i=0; i< files.length; i++) {
		System.out.println("Root: "+files[i].toString()+"\n");
	    }
	    */
	    
	    System.out.println("Directory name: "+dirName);

	    File thisDir=new File(dirName);
	    if(thisDir.isDirectory()) System.out.println("This is a directory");
	    else System.out.println("This is NOT a direstory");

	    fileList=thisDir.list();
	    for(int i=0;i<fileList.length;i++)
		System.out.println("File List: "+fileList[i]);

	}
	catch(Exception ex) {
	    System.err.println("Couldn't open the file.");
	    ex.printStackTrace();
	}
	return fileList;
    }        
        
    
    /**
     * Add the nodes to the tree.  If the node is a file, it will have
     * no children. There is a hackish way for checking for directories.
     * I will not construct the entire directory tree at the beginning. 
     * Instead, I will do this when I receive a tree expansion event.
     */
    public void addNodes(DefaultMutableTreeNode parent, DefaultTreeModel model,
			 String[] fileList, String parentDir){
	if(fileList.length>0) {
	    for(int i=0;i<fileList.length;i++){
		DefaultMutableTreeNode tmpNode=
		    new DefaultMutableTreeNode();
		if((new File(parentDir+fileList[i])).isDirectory()){
		    addNodes(tmpNode,model,new String[0],fileList[i]);
		}
		tmpNode.setUserObject(fileList[i]);
		model.insertNodeInto(tmpNode,parent,parent.getChildCount());
	    }
	}
	else {
	    DefaultMutableTreeNode tmpNode=new DefaultMutableTreeNode();
	    tmpNode.setUserObject("<Empty>");
	    model.insertNodeInto(tmpNode,parent,parent.getChildCount());
	}
	
    }
    
}


